SystemOrganization addCategory: #Squeak2JS!

OMeta subclass: #S2JParser
	instanceVariableNames: ''
	classVariableNames: 'TypeTable'
	poolDictionaries: ''
	category: 'Squeak2JS'!

!S2JParser class methodsFor: 'as yet unclassified' stamp: 'ag 11/17/2010 17:35'!
initialize
"
	OSqueakParser initialize.
"
	super initialize.
	self compilerClass: OMetaCompiler.
	
	TypeTable := #(#xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xDelimiter #xDelimiter #xBinary #xDelimiter #xDelimiter #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #doIt #xBinary #xDelimiter #xBinary #xDoubleQuote #xLitQuote #xDollar #xBinary #xBinary #xSingleQuote #leftParenthesis #rightParenthesis #xBinary #xBinary #xBinary #xBinary #period #xBinary #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xDigit #xColon #semicolon #xBinary #xBinary #xBinary #xBinary #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #leftBracket #xBinary #rightBracket #upArrow #leftArrow #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #leftBrace #verticalBar #rightBrace #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xLetter #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xBinary #xLetter #xBinary #xBinary #xBinary #xBinary #xLetter #xBinary #xBinary #xBinary #xBinary #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xBinary #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xLetter #xBinary)! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:44'!
arrayConstr ::=

	<token '{'> <expr>:x (<token '.'> <expr>)*:xs (<token '.'> | <empty>) <token '}'>	=> [{'{'. self	concat: (xs addFirst: x; yourself)
																						delim: '. '. '}'}]
|	<token '{'> <token '}'>														=> ['{}']! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:44'!
arrayLit ::=

	<token '#'> <token '('>	( <literal>
							| <arrayLit>
							| <spaces> <tsArraySymbol> )*:xs <token ')'>	=> [{'#('. self	concat: xs
																						delim: ' '. ')'}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:45'!
binary ::=

	<spaces> <tsBinary>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:45'!
binaryExpr ::=

	<binaryExpr>:r <binaryMsg>:m	=> [{r. ' '. m}]
|	<unaryExpr>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:45'!
binaryMsg ::=

	<binary>:s <unaryExpr>:a	=> [{s. ' '. a}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:46'!
block ::=

	<token '['>

		( (<token ':'> <identifier>)+:args <token '|'> 		=> [{':'. self	concat: args
																	delim: ' :'. '|'}]
		| <empty>										=> ['']							):args

		( <token '|'> <identifier>*:ts <token '|'>				=> [{' | '. self	concat: ts
																		delim: ' '. ' | '}]
		| <empty>										=> ['']							):tmps

		( <expr>:x (<token '.'> <expr>)*:xs					=> [self	concat: (xs	addFirst: x;
																			yourself)
																delim: '. ']
		| <empty>										=> ['']							):body

		( (?[body = ''] | <token '.'>) <token '^'> <expr>:r	=> [{'. ^'. r}]
		| <empty>										=> ['']							):ret

		( <token '.'>
		| <empty>		 )

		<token ']'>
														=> [{'['. args. tmps. body. ret. ']'}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:46'!
cascade ::=

	<identifier>
|	<binaryMsg>
|	<keywordMsg>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:46'!
expr ::=

	<identifier>:v (<token ':='> | <token '_'>) <expr>:e	=> [{v. ' := '. e}]
|	<msgExpr>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:46'!
flattenedExpr ::=

	<expr>:e <empty e> <foreign OParseTreeFlattener #flatten>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:47'!
flattenedUnit ::=

	<unit>:u <empty u> <foreign OParseTreeFlattener #flatten>
! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:47'!
identifier ::=

	<spaces> <tsIdentifier>:i ~$:	=> [i]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:47'!
keyword ::=

	<spaces> <tsKeyword>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:47'!
keywordExpr ::=

	<binaryExpr>:r <keywordMsg>:m	=> [{r. ' '. m}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:47'!
keywordMsg ::=

	<keywordMsg>:m <keywordMsgPart>:p	=> [{m. ' '. p}]
|	<keywordMsgPart>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:47'!
keywordMsgPart ::=

	<keyword>:k <binaryExpr>:x	=> [{k. ' '. x}]
! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:47'!
literal ::=

	<spaces>	( <tsNumber>
			| <tsCharacter>
			| <tsString>
			| <tsSymbol>    )
! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:48'!
msgExpr ::=

	( <keywordExpr>
	| <binaryExpr>  ):e (<token ';'> <cascade>:c => [{'; '. c}])*:cs	=> [{e. cs}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:48'!
symbol ::=

	<token '#'> <spaces>
		( <tsString>
		| <tsKeyword>*:ks	( <tsIdentifier>
							| <empty> => [''] ):i => [{ks. i}] ):s
		=> [{'#'. s}]
! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:48'!
tcBinaryChar ::=

	<char>:x ?[(TypeTable at: x asciiValue) == #xBinary]	=> [x]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:48'!
token :xs ::=

	<spaces> <seq xs>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:48'!
tsArraySymbol ::=

	<tsKeyword>+:ks	( <tsIdentifier>
					| <empty> => [''] ):i	=> [{ks. i}]
|	<tsIdentifier>! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:48'!
tsBinary ::=

	($| | <tcBinaryChar>):x <tcBinaryChar>*:xs => [{x asString. xs}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:48'!
tsCharacter ::=

	$$ <char>:c	=> [String with: $$ with: c]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:49'!
tsIdentifier ::=

	<letter>:x (<letter> | <digit>)*:xs => [{x asString. xs}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:49'!
tsKeyword ::=

	<tsIdentifier>:i $: => [{i. ':'}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:49'!
tsNatural ::=

	<digit>+! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:49'!
tsNumber ::=

	($+ | <empty>)	<tsNatural>
|	$-				<tsNatural>:i	=> [{'-'. i}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:50'!
tsString ::=

	$' ($' $' | ~$' <char>)*:xs $'	=> [(String withAll: xs) printString]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:50'!
tsSymbol ::=

	$#	<spaces>	(<tsString> | <tsArraySymbol>):s	=> [{'#'. s}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:50'!
unaryExpr ::=

	<unit>:e <identifier>*:ms	=> [{	e.
								ms size > 0 ifTrue: [' '] ifFalse: [''].
								self	concat: ms
									delim: ' '}]! !

!S2JParser methodsFor: 'as yet unclassified' stamp: 'aw 8/13/2007 16:50'!
unit ::=

	<literal>
|	<identifier>
|	<arrayLit>
|	<arrayConstr>
|	<block>
|	<token '('> <expr>:e <token ')'>	=> [{'('. e. ')'}]! !
S2JParser initialize!
